<?php
//=================================================================
// KOOBI R7 - CMS - PORTALSOFTWARE(c) DREAM4(r) 
// HTTP://WWW.DREAM4.DE
//=================================================================
// ACHTUNG!
// DIESER PROGRAMMCODE IST URHERRECHTLICH GESCHUETZT
// DIE URHEBERRECHTE LIEGEN BEI DEN JEWEILIGEN AUTOREN.
// AENDERUNGEN IN DIESER DATEI ERFOLGEN AUF EIGENE GEFAHR!
// ES IST NICHT GESTATTET, DEN COPYRIGHTHINWEIS ZU AENDERN ODER ZU
// ENTFERNEN. NUR WENN SIE EINE COPYRIGHTHINWEIS-ENTFERNUNG BESTELLT
// HABEN, DUERFEN SIE DIESEN ENTFERNEN.
//=================================================================
// BEI FRAGEN WENDEN SIE SICH BITTE AN: KONTAKT@DREAM4.DE
//=================================================================
$SESS_DBHOST = @$config['dbhost'];	
$SESS_DBNAME = @$config['dbname'];			
$SESS_DBUSER = @$config['dbuser'];		
$SESS_DBPASS = @$config['dbpass'];		
$DB_PREFIX = @$config['dbprefix'];

$SESS_DBH = "";
$SESS_LIFE = 2700; //(get_cfg_var("session.gc_maxlifetime") < 1440) ? 2400 : "";

function sess_open($save_path, $session_name)
{
	global $DB_PREFIX, $SESS_DBHOST, $SESS_DBNAME, $SESS_DBUSER, $SESS_DBPASS, $SESS_DBH;

	if (!$SESS_DBH = @mysql_connect($SESS_DBHOST, $SESS_DBUSER, $SESS_DBPASS))
	{
		echo "<li>Can't connect to $SESS_DBHOST as $SESS_DBUSER";
		echo "<li>MySQL Error: ", mysql_error();
		die;
	}

	if (! mysql_select_db($SESS_DBNAME, $SESS_DBH))
	{
		echo "<li>Unable to select database $SESS_DBNAME";
		die;
	}

	return true;
}

function sess_close() {
	return true;
}

function sess_read($key)
{
	global $DB_PREFIX,$SESS_DBH, $SESS_LIFE;

	$qry = "SELECT Wert FROM ".$DB_PREFIX. "_sessions WHERE Schluessel = '$key' AND Ablauf > " . time() . "";
	$qid = mysql_query($qry, $SESS_DBH);

	if (list($value) = @mysql_fetch_row($qid)) {
		return $value;
	} else {
		$qry = "DELETE FROM ".$DB_PREFIX. "_sessions WHERE Schluessel = '$key' AND Ablauf < " . time() . "";
		$qid = mysql_query($qry, $SESS_DBH);
	}

	return false;
}

function sess_write($key, $val) 
{
	global $DB_PREFIX,$SESS_DBH, $SESS_LIFE;

	$key = ereg_replace('([^_A-Za-zÀ-ÖØ-öø-ÿ0-9-])', '', $key);
	$expiry = time() + $SESS_LIFE;
	$expire_datum = date("d.m.Y, H:i:s", $expiry);
	$value = addslashes($val);

	$qry = "INSERT INTO ".$DB_PREFIX. "_sessions VALUES ('$key', $expiry, '$value')"; //, '".$_SERVER['REMOTE_ADDR']."'
	$qid = mysql_query($qry, $SESS_DBH);

	if (!$qid)
	{
		//
		$qry = "UPDATE ".$DB_PREFIX. "_sessions SET Ablauf = $expiry, Wert = '$value'  WHERE Schluessel = '$key'  AND Ablauf > " . time();
		$qid = mysql_query($qry, $SESS_DBH);
	}
	return $qid;
}

function sess_destroy($key) {
	global $DB_PREFIX,$SESS_DBH;

	$qry = "DELETE FROM ".$DB_PREFIX. "_sessions WHERE Schluessel = '$key'";
	$qid = mysql_query($qry, $SESS_DBH);

	return $qid;
}

function sess_gc($maxlifetime) {
	global $DB_PREFIX,$SESS_DBH;

	$qry = "DELETE FROM ".$DB_PREFIX. "_sessions WHERE Ablauf < " . time();
	$qid = mysql_query($qry, $SESS_DBH);

	return mysql_affected_rows($SESS_DBH);
}

session_set_save_handler(
	"sess_open",
	"sess_close",
	"sess_read",
	"sess_write",
	"sess_destroy",
	"sess_gc");
?>